#!/usr/bin/env node
import o from "chalk";
import { execSync as g } from "node:child_process";
import p, { resolve as R } from "node:path";
import f, { existsSync as y, rmSync as h } from "node:fs";
import a from "prompts";
import { onPromptFormStateForSigint as l, lookForParentTarget as D } from "@done-coding/cli-utils";
import { getConfigPath as M, batchHandler as _ } from "@done-coding/cli-template";
import { getTargetRepoUrl as O } from "@done-coding/cli-git";
import L from "yargs";
import { hideBin as I } from "yargs/helpers";
const d = {
  version: "0.9.3-alpha.0",
  name: "create-done-coding",
  description: "项目创建命令行工具",
  cliConfig: {
    namespaceDir: ".done-coding",
    moduleName: "create"
  }
}, j = "git@gitee.com:justsosu/done-coding-cli-config-json.git", C = "自定义模版路径", S = "某个git平台用户仓库", U = `./.${d.name}_temp`;
let $;
const A = async () => ($ || ($ = (await q()).templateList), $), x = async () => [
  ...await A(),
  { name: C },
  { name: S }
], H = {
  type: "text",
  name: "projectName",
  message: "请输入项目名称",
  format: (e) => e.trim(),
  validate: (e) => e.length > 0 || "项目名称不能为空",
  onState: l
}, k = async () => ({
  type: "select",
  name: "template",
  message: "请选择模板",
  choices: (await x()).map((t) => {
    var i;
    return {
      title: t.branch ? `${t.name}(${t.branch})` : t.name,
      value: t.name,
      description: `${t.description || ""}${(i = t.instances) != null && i.length ? `, 已应用于: ${[""].concat(t.instances).join(`
- `)}` : ""}` || void 0
    };
  }),
  validate: (t) => t.trim().length > 0 || "模板不能为空",
  onState: l
}), B = {
  type: "confirm",
  name: "saveGitHistory",
  message: "是否保留git历史",
  initial: !1,
  onState: l
}, b = (e = "项目已存在，是否删除") => ({
  type: "confirm",
  name: "isRemove",
  message: e,
  onState: l
}), Y = {
  type: "text",
  name: "customUrl",
  message: "请输入自定义模板路径",
  validate: (e) => e.trim().length > 0 || "路径不能为空",
  onState: l
}, J = (e) => ({
  type: "text",
  name: "gitCommitMessage",
  message: "请输入git提交信息",
  initial: `feat: 初始化项目${e}`,
  validate: (t) => t.trim().length > 0 || "提交信息不能为空",
  onState: l
}), q = async () => {
  console.log(o.blue("拉取模板列表，请稍等..."));
  const e = p.resolve(
    process.cwd(),
    U
  );
  if (y(e))
    return console.log(o.red(`${e} 已存在，请手动删除该目录再试`)), process.exit(1);
  if (console.log(o.blue(`配置临时目录：${e}`)), f.existsSync(e)) {
    const i = `${e}目录已存在，是否删除？`, { isRemove: r } = await a(b(i));
    if (r)
      f.rmSync(e, { recursive: !0, force: !0 });
    else
      return console.log(o.red(`${e}已存在，请手动删除后再试！`)), process.exit(1);
  }
  let t;
  try {
    g(`git clone ${j} ${e} --depth=1`);
    const i = d.name, r = p.resolve(e, `${i}.json`);
    if (t = JSON.parse(f.readFileSync(r, "utf-8")), !Array.isArray(t.templateList)) {
      const n = `远程配置文件出错, templateList 不是数组, 请检查 ${j} ${i}.json`;
      throw new Error(n);
    }
    console.log(o.green("模板列表拉取成功！"));
  } finally {
    f.rmSync(e, { recursive: !0, force: !0 });
  }
  return t;
}, E = async (e) => {
  const { projectName: t } = e, r = ((t ?? (await a(H)).projectName) || "").trim();
  if (!r)
    return console.log(o.red("项目名称不能为空")), process.exit(1);
  if (r.includes(" ") || r.includes("\\") || r.includes("/"))
    return console.log(o.red(`项目名称\`${r}\`不能包含空格或者\\或者/`)), process.exit(1);
  const n = R(process.cwd(), r);
  if (y(n)) {
    const { isRemove: s } = await a(b());
    if (s === !0)
      h(n, { recursive: !0, force: !0 });
    else
      return console.log(o.red("项目已存在")), process.exit(1);
  }
  const { template: m } = await a(await k());
  let u = "", v = "";
  if (m === C) {
    const { customUrl: s } = await a(Y);
    u = s;
  } else if (m === S)
    u = await O();
  else {
    const s = (await x()).find(
      (c) => c.name === m
    );
    if (!s)
      return console.log(o.red(`模板${m}不存在`)), process.exit(1);
    if (!s.url)
      return console.log(o.red(`模板${m}仓库地址不存在`)), process.exit(1);
    u = s.url, v = s.branch;
  }
  const w = D(".git");
  console.log(o.blue("正在初始化项目，请稍等...")), g(
    `git clone${v ? ` -b ${v}` : ""} ${u} ${r} --depth=1`,
    { stdio: "inherit" }
  );
  const N = M(n);
  if (N && (await _({
    rootDir: n,
    extraEnvData: {
      $projectName: r
    }
  }), h(N, { force: !0 }), console.log(o.blue("模板项目配置注入成功, 模版项目配置文件已删除"))), console.log(o.blue("项目初始化完成")), w) {
    const s = p.resolve(n), c = p.resolve(s, ".git");
    if (!y(c))
      throw new Error("git目录不存在");
    h(c, { recursive: !0, force: !0 }), console.log(
      o.green(
        `项目创建在父级git仓库${w}中，已删除${r}目录下的.git(${c})`
      )
    );
  } else if ((await a(B)).saveGitHistory)
    g("git remote rename origin upstream && git fetch --unshallow", {
      cwd: n,
      stdio: "inherit"
    }), console.log(
      o.green(
        "已经将origin重命名为upstream，后续可以与模板git仓库有完整的交互"
      )
    ), console.log(o.green("已保存git历史记录"));
  else {
    const c = p.resolve(n, ".git");
    h(c, { recursive: !0, force: !0 }), g("git init", {
      cwd: n,
      stdio: "inherit"
    });
  }
  const { gitCommitMessage: P } = await a(
    J(r)
  );
  g(`git add . && git commit -m '${P}'`, {
    cwd: n,
    stdio: "inherit"
  }), console.log(o.green(`项目${r}初始化完成`)), console.log(
    o.blue(`
使用步骤: 
  1. cd ${r}
  2. pnpm install
  3. pnpm run dev
  `)
  );
}, G = d.cliConfig.moduleName, z = (e, t) => {
  console.log(e ? o.red(e) : o.red(t.message)), process.exit(1);
}, T = d.description, K = `$0 ${G} [projectName]`, Q = "$0 [projectName]", F = async (e, t) => e.strict().usage(`Usage: ${t}`).help("help").version(d.version).alias("v", "version").alias("h", "help").command({
  command: t,
  describe: T,
  handler: E
}).fail(z).argv, ie = {
  command: G,
  describe: T,
  builder: (e) => F(e, K),
  handler: E
}, ce = async () => {
  const e = L(I(process.argv));
  return await F(e, Q);
};
export {
  ie as a,
  ce as c,
  E as h
};
